//+------------------------------------------------------------------+
//|                                                  DollarHedge.mq4 |
//|                      Copyright  2007, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

//---- input parameters
extern int       EurUsdLots=3;
extern int       GbpUsdLots=3;
extern int       UsdJpyLots=4;
extern int       UsdChfLots=4;
extern double    ProfitTarget=150.0;

int EurUsdTicket = 0;
int GbpUsdTicket = 0;
int UsdJpyTicket = 0;
int UsdChfTicket = 0;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   buy();
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   close();
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
      if (!PositionsOpen())
      {
         buy();
      }  
      double pl = TotalProfit();
      if (pl >= ProfitTarget)
      {
         close();
         Sleep(5000);
      }
//----
   return(0);
  }
  
int buy ()
{
   int EurUsdTicket = OrderSend("EURUSD",OP_BUY,EurUsdLots,MarketInfo("EURUSD",MODE_ASK),0,0,0,NULL,12345,0,CLR_NONE);
   int GbpUsdTicket = OrderSend("GBPUSD",OP_BUY,GbpUsdLots,MarketInfo("GBPUSD",MODE_ASK),0,0,0,NULL,12346,0,CLR_NONE);
   int UsdJpyTicket = OrderSend("USDJPY",OP_BUY,UsdJpyLots,MarketInfo("USDJPY",MODE_ASK),0,0,0,NULL,12347,0,CLR_NONE);
   int UsdChfTicket = OrderSend("USDCHF",OP_BUY,UsdChfLots,MarketInfo("USDCHF",MODE_ASK),0,0,0,NULL,12348,0,CLR_NONE);
   return (0);
}

int close ()
{
   OrderClose(EurUsdTicket,EurUsdLots,MarketInfo("EURUSD",MODE_BID),0,CLR_NONE);
   OrderClose(GbpUsdTicket,GbpUsdLots,MarketInfo("GBPUSD",MODE_BID),0,CLR_NONE);
   OrderClose(UsdJpyTicket,UsdJpyLots,MarketInfo("USDJPY",MODE_BID),0,CLR_NONE);
   OrderClose(UsdChfTicket,UsdChfLots,MarketInfo("USDCHF",MODE_BID),0,CLR_NONE);
}

bool PositionsOpen ()
{
   int total = OrdersTotal();
   if (total > 0)
      return (true);
   else
      return (false);
}

double TotalProfit ()
{
   double pl = 0.0;
   OrderSelect(EurUsdTicket,SELECT_BY_TICKET, MODE_TRADES);
   pl += OrderProfit();
   OrderSelect(GbpUsdTicket,SELECT_BY_TICKET, MODE_TRADES);
   pl += OrderProfit();
   OrderSelect(UsdJpyTicket,SELECT_BY_TICKET, MODE_TRADES);
   pl += OrderProfit();
   OrderSelect(UsdChfTicket,SELECT_BY_TICKET, MODE_TRADES);
   pl += OrderProfit();
   
   return (pl);
   
}
//+------------------------------------------------------------------+